# Just:In.Time
# This script extracts pixel information from an image and outputs 
# an rgbw array that can be copied to the just_in_time.ino Arduino script.
# By John Opsahl, February 2020

import os
from PIL import Image

image_filepath = os.path.join('C:\\Users\johno\Desktop\Projects_General\led_timelapse\images', 'womanyellingatcat.png')
image = Image.open(image_filepath, 'r')

image_width = image.size[0]
image_height = image.size[1]

# color of each pixel in a list; ordered left to right, top to bottom
pixel_color = list(image.getdata())

# convert rgb value tuples to list
pixel_color = [list(rgb_val) for rgb_val in pixel_color]

# add w pixel value to rgb values because rgbw LEDs are used
for rgb_val in pixel_color:
    # if rgb white (255, 255, 255) change to rgbw white (0, 0, 0, 255)
    if rgb_val[0] >= 200 and rgb_val[1] >= 200 and rgb_val[2] >= 200:
        rgb_val = [0, 0, 0, 255]
    elif len(rgb_val) == 3:
        rgb_val.append(0)
    elif len(rgb_val) == 4:
        rgb_val[3] = 0

led_pixel_rgbw = [[] for x in range(image_width)]

# separate color values into columns
for i in range(0, image_width):
    for j in range(0, image_height):
        led_pixel_rgbw[i].append(pixel_color[i + j*image_width])

c_pixel_array = '{'
for i in range(0, image_width):
    c_pixel_array += '{'
    for j in range(0, image_height):
        c_pixel_array += '{'
        for k in range(0, 4):
            c_pixel_array += str(led_pixel_rgbw[i][j][k])
            if k != 3:
                c_pixel_array += ','
        c_pixel_array += '}'
        if j != image_height - 1:
            c_pixel_array += ','
    c_pixel_array += '}'
    if i != image_width - 1:
        c_pixel_array += ','
c_pixel_array += '}'

print(c_pixel_array)

print('image width =', image_width)
print('image height =', image_height)